:- module(db,[get_article/2,get_value/3,get_mother_comp/2]).

:- use_module(library(lists)).

% *********************************************

% *           Articles DataBase               *

% *********************************************

article('17inch',[price(100),category(monitor)]).

article('19inch',[price(200),category(monitor)]).

article('64Mb',[price(100),category(ram)]).

article('128Mb',[price(200),category(ram)]).

article('256Mb',[price(300),category(ram)]).

article('pIII500',[price(100),category(cpu),firm(intel)]).

article('pIII800',[price(200),category(cpu),firm(intel)]).



article('k6',[price(200),category(cpu),firm(amd)]).

article('asusp3',[price(400),category(mother),compatible(intel)]).

article('asusk6',[price(400),category(mother),compatible(amd)]).

article(audio,[price(50),category(peripheral)]).

article(modem,[price(50),category(peripheral)]).

article(plotter,[price(50),category(peripheral)]).

article(printer,[price(50),category(peripheral)]).

article(scanner,[price(50),category(peripheral)]).

article(zip,[price(50),category(peripheral)]).



% DB UTILITIES



get_article(Prop,Article):-

	article(Article,Cs),

	member(Prop,Cs).

	

 

get_value(Art,Prop,Value):-

	article(Art,Cs),

	X =.. [Prop,Value],

	member(X,Cs).





get_mother_comp(Cpu,Mother):-

	get_value(Cpu,firm,Firm),

	get_value(Mother,category,mother),

	get_value(Mother,compatible,Firm).

